// ExtPNewPanBar.cpp : implementation file
//

#include "stdafx.h"
#include "VisioDraw.h"
#include "ExtPNewPanBar.h"
 

/////////////////////////////////////////////////////////////////////////////
// CExtPNewPanBar

/////////////////////////////////////////////////////////////////////////////
// CExtPNewPanBar

CExtPNewPanBar::CExtPNewPanBar()
{
	rcOldCanvas = CRect(0,0,10,10);
}

CExtPNewPanBar::~CExtPNewPanBar()
{
}


BEGIN_MESSAGE_MAP(CExtPNewPanBar, CDockablePane)
//{{AFX_MSG_MAP(CExtPNewPanBar)
ON_WM_CREATE()
ON_WM_SIZE()
ON_WM_ERASEBKGND()
ON_WM_VSCROLL()
ON_WM_PAINT()
ON_WM_TIMER()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CExtPNewPanBar message handlers

#define FOP_NEWPANWND_ID 3234
#define IDC_FO_SLIDER_NEW 3235

int CExtPNewPanBar::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDockablePane::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	CRect rcPos = CRect(0,0,100,100);
	DWORD dwStyle = WS_CHILD | WS_VISIBLE;
	m_wndPan.SetActiveView(NULL);
	m_wndPan.Create(dwStyle,rcPos,this,FOP_NEWPANWND_ID);
	
	if (!m_wndSlider.Create(TBS_VERT | TBS_AUTOTICKS | WS_CHILD | WS_VISIBLE,
		CRect(0, 0, 200, 16), this, IDC_FO_SLIDER_NEW))
	{
		return FALSE;
	}
	
	// Set the maximum range of the Slider control's scroll bar.
	
	m_wndSlider.SetRange(-11, 0);
	m_wndSlider.SetTicFreq(1);
	SetTimer(FOP_TIMER_ID, 800, NULL);
	return 0;
}

void CExtPNewPanBar::OnTimer(UINT_PTR nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (IsVisible())
    {
        m_wndPan.UpdateNow(FALSE);
    }
	CDockablePane::OnTimer(nIDEvent);
}

void CExtPNewPanBar::OnSize(UINT nType, int cx, int cy) 
{
	CDockablePane::OnSize(nType, cx, cy);
	if( m_wndPan.GetSafeHwnd() != NULL )
	{
		CRect r;
		GetClientRect(&r);
		r.right -= 20;
		m_wndPan.SetWindowPos( NULL, r.left, r.top, r.Width(), r.Height(), SWP_NOZORDER|SWP_NOACTIVATE );

		r.left = r.right;
		r.right += 20;
		m_wndSlider.SetWindowPos( NULL, r.left, r.top, r.Width(), r.Height(), SWP_NOZORDER|SWP_NOACTIVATE );
		if (GetActiveView()) 
		{
			CRect rect;
			GetClientRect(&rect);
			rect.right -= 20;
			if(IsFloating())
			{
				
				rect.InflateRect(15,15,15,15);
			}
			else
			{
				rect.InflateRect(6,6,6,6);
			}
			
			CFODataModel* pModel = GetActiveView()->GetCurrentModel();
			
			if(pModel == NULL)
				return;

			m_wndPan.ReCalcViewPos(rect);
			
		}
	}
}

void CExtPNewPanBar::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// This  member function is called when the Slider control is scrolled.
	
	// Determine if the WM_VSCROLL message is from the Slider control's scroll bar.
	if ((CSliderCtrl*)pScrollBar == &m_wndSlider)
	{
		if (m_wndPan.GetActiveView())
		{
			int nSelection = m_wndSlider.GetPos();
			int nPercent = 100;
			switch (nSelection)
			{
			case 0:
				nPercent = 5;
				break;
			case -1:
				nPercent = 10;
				break;
			case -2:
				nPercent = 50;
				break;
			case -3:
				nPercent = 75;
				break;
			case -4:
				nPercent = 100;
				break;
			case -5:
				nPercent = 150;
				break;
			case -6:
				nPercent = 200;
				break;
			case -7:
				nPercent = 300;
				break;
			case -8:
				nPercent = 400;
				break;
			case -9:
				nPercent = 600;
				break;
			case -10:
				nPercent = 800;
				break;	
			case -11:
				nPercent = 1000;
				break;	
			}
			GetActiveView()->SetNewZoomScale(nPercent);
		}
	}
	
	// Let the base class handle the message.
	CDockablePane::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CExtPNewPanBar::OnPaint() 
{
	CPaintDC dc(this);
	
	CRect rectClient;
	GetClientRect(&rectClient);

	CFOPDrawDC memDC(&dc, rectClient, RGB(255,255,255));
	CFODrawHelper::FillRectFast(&memDC, rectClient, RGB(144,153,174));
	if (IsVisible())
	{
		DoPaint(&memDC);
	}
}

BOOL CExtPNewPanBar::OnEraseBkgnd( CDC* pDC )
{
	CDockablePane::OnEraseBkgnd(pDC);
	return TRUE;
}

void  CExtPNewPanBar::SetActiveView(CFOPCanvasCore* pView)
{
	if(m_wndPan.GetActiveView()==pView)
	{
		m_wndPan.SetActiveView(pView);
		return;
	}

	m_wndPan.SetActiveView(pView);
	if(pView != NULL) 
	{
		CRect rect;
		GetClientRect(&rect);
		rect.right -= 20;
		if(IsFloating())
		{
			
			rect.InflateRect(15,15,15,15);
		}
		else
		{
			rect.InflateRect(6,6,6,6);
		}
		m_wndPan.ReCalcViewPos(rect);
		m_wndPan.ShowWindow(SW_SHOW);
		Invalidate(TRUE);
	} 
	else
	{
		if(m_wndPan.GetSafeHwnd() != NULL)
		{
			m_wndPan.ShowWindow(SW_HIDE);
		}
		Invalidate(TRUE);
	}
}

CFOPCanvasCore *CExtPNewPanBar::GetValidActiveView()
{
	return m_wndPan.GetValidActiveView();
}

CFOPCanvasCore* CExtPNewPanBar::GetActiveView() 
{
	return m_wndPan.GetActiveView();
}

int CExtPNewPanBar::ConvertSacle(const double &dScale)
{
	int nPos = 0;
	if(dScale <= 5)
	{
		nPos = 0;
	}
	else if(dScale <= 10)
	{
		nPos = -1;
	}
	else if(dScale <= 50)
	{
		nPos = -2;
	}
	else if(dScale <= 75)
	{
		nPos = -3;
	}
	else if(dScale <= 100)
	{
		nPos = -4;
	}
	else if(dScale <= 150)
	{
		nPos = -5;
	}
	else if(dScale <= 200)
	{
		nPos = -6;
	}
	else if(dScale <= 300)
	{
		nPos = -7;
	}
	else if(dScale <= 400)
	{
		nPos = -8;
	}
	else if(dScale <= 600)
	{
		nPos = -9;
	}
	else if(dScale <= 800)
	{
		nPos = -10;
	}
	else
	{
		nPos = -11;
	}

	return nPos;
}

void CExtPNewPanBar::UpdateWnd(const BOOL &bRedraw) 
{
	if(!IsWindowVisible())
	{
		return;
	}
    
	m_wndPan.mRedrawMapImage = true;
}

void CExtPNewPanBar::RedrawWindow()
{
	m_wndPan.mRedrawMapImage = true;
}

void CExtPNewPanBar::UpdateZoomScale()
{
	if(!IsWindowVisible())
	{
		return;
	}
    
	if(m_wndPan.GetActiveView()) 
	{
//		CRect rcNew = GetActiveView()->GetCurrentModel()->GetPagePosition();
		m_wndSlider.SetPos(ConvertSacle(GetActiveView()->GetZoomScale()*100.00));
// 		if(rcNew != rcOldCanvas)
// 		{
// 			rcOldCanvas = rcNew;
// 			Invalidate();
// 		}
	}
}
