// MyBackShape.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "VisioDraw.h"
#include "MyBackShape.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// CMyBackShape Class
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFOImageData CMyBackShape::m_ImageData;
//////////////////////////////////////////////////////////////////////
// CMyBackShape Class
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL(CMyBackShape, CFOBackShape, 0)
CMyBackShape::CMyBackShape(CFODataModel *pModel)
{
	//Load in the map bitmap
 
	m_pImagePtr				=	NULL;
	m_pImageRotatePtr		=	NULL;
	m_pImagePtrAndMask		=	NULL;
	m_pImagePtrOrMask		=	NULL;
	m_bImageTransparent		=	FALSE;
	m_crImageTransparent	=	gfxData.m_crBtnFace;
	m_nImageType			= -1;
	m_nTimerID				= -1;
	m_nFrame				= 0;
	m_bGif					= FALSE;
	m_ptImageStart			= FOPPoint(0,0);
	m_rectPosition.SetRectEmpty();
	m_strImageFile			= _T("");
	m_bCenterImage			= TRUE;
}

CMyBackShape::CMyBackShape(const CMyBackShape& src)
{
	m_pImagePtr				=	NULL;
	m_pImageRotatePtr		=	NULL;
	m_pImagePtrAndMask		=	NULL;
	m_pImagePtrOrMask		=	NULL;
	m_bImageTransparent		=	FALSE;
	m_bCenterImage			= TRUE;
	m_crImageTransparent	=	gfxData.m_crBtnFace;
	m_nImageType			= -1;
	m_nTimerID				= -1;
	m_nFrame				= 0;
	m_bGif					= FALSE;
	m_ptImageStart			= FOPPoint(0,0);
	m_rectPosition.SetRectEmpty();
	m_strImageFile			= _T("");
	*this = src;
}

CMyBackShape::~CMyBackShape()
{
	if(m_pImageRotatePtr != NULL)
	{
		delete m_pImageRotatePtr;
		m_pImageRotatePtr = NULL;
	}
	
	if(m_pImagePtrOrMask != NULL)
	{
		delete m_pImagePtrOrMask;
		m_pImagePtrOrMask = NULL;
	}
	
	if(m_pImagePtrAndMask != NULL)
	{
		delete m_pImagePtrAndMask;
		m_pImagePtrAndMask = NULL;
	}

	if(m_pImagePtr != NULL)
	{
//		delete m_pImagePtr;
		m_pImagePtr = NULL;
	}

	m_strImageFile			= _T("");
}

/////////////////////////////////////////////////////////////////////////////
// CMyBackShape diagnostics

#ifdef _DEBUG
void CMyBackShape::AssertValid() const
{
	CFOBackShape::AssertValid();
}

void CMyBackShape::Dump(CDumpContext& dc) const
{
	CFOBackShape::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////

CMyBackShape& CMyBackShape::operator=(const CMyBackShape& src)
{
	(*(CFOBackShape*)this) = src;
	m_bImageTransparent			=	src.IsImageTransparent();
	m_crImageTransparent		=	src.GetImageTransparentColor();
	
	m_pImagePtr					=	src.m_pImagePtr;
	
	if(m_pImageRotatePtr != NULL)
		delete m_pImageRotatePtr;
	
	m_pImageRotatePtr			=	NULL;
	m_nImageType				=	src.m_nImageType;
	m_bGif						=	src.m_bGif;
	m_rectPosition				=   src.m_rectPosition;
	m_strImageFile				=   src.m_strImageFile;
	m_ptImageStart				=	src.m_ptImageStart;
	m_bCenterImage				=   src.m_bCenterImage;
	SetNewImage(m_strImageFile);

	return (*this);
}

CFOBackShape* CMyBackShape::Copy() const
{
	return (new CMyBackShape(*this));
}

CString CMyBackShape::SetNewImage(const CString &strImage)
{
	if(strImage.IsEmpty())
	{
		m_strImageFile = _T("");
		return  _T("");
	}
	
	CancelImage();
	
	CString strFileName = theApp.GetMediaPath() + strImage;
	if(!theApp.XFileExists(strFileName))
	{
		m_strImageFile = _T("");
		return _T("");
	}

	m_strImageFile = strImage; 

	CString filename(strFileName);
	CString ext(CFODrawHelper::FindExtension(filename));
	ext.MakeLower();
	if (ext == _T(""))
	{
		return _T("");
	}
	
	FO_IMAGETYPE type = CFODrawHelper::FindType(ext);
	BOOL bLoad = LoadImage(strFileName,type);

			if(!bLoad)
			{
				return _T("");
			}
	int nAngle = 0;
	CFOBitmap *pTempImage = m_pImagePtr->GetBitmap();
	m_DrawImage.m_nAngle = nAngle;
	m_DrawImage.RebuildImage(pTempImage);

	return strImage;
}

BOOL CMyBackShape::DoImageLoading()
{
    CString strFilter;
	strFilter.LoadString(IDS_FO_IMAGE_EXTENSION);
	
	CString title;
	title.LoadString(IDS_FO_OPEN_FILE_TITLE);
	CFileDialog dlgFile (TRUE,NULL,NULL,OFN_HIDEREADONLY| OFN_OVERWRITEPROMPT,strFilter,AfxGetMainWnd());
	if(dlgFile.DoModal() == IDOK)
	{
		if (dlgFile.GetFileExt().CompareNoCase(_T("wmf")) == 0)
		{
			return FALSE;
		}
		else if(dlgFile.GetFileExt().CompareNoCase(_T("emf")) == 0)
		{
			return FALSE;
		}
		else
		{
			CString strFileName = dlgFile.GetPathName();
			CString filename(strFileName);
			CString ext(CFODrawHelper::FindExtension(filename));
			ext.MakeLower();
			if (ext == _T(""))
			{
				return FALSE;
			}
			
			if(m_pImageRotatePtr != NULL)
			{
				delete m_pImageRotatePtr;
				m_pImageRotatePtr = NULL;
			}
			
			if(m_pImagePtrOrMask != NULL)
			{
				delete m_pImagePtrOrMask;
				m_pImagePtrOrMask = NULL;
			}
			
			if(m_pImagePtrAndMask != NULL)
			{
				delete m_pImagePtrAndMask;
				m_pImagePtrAndMask = NULL;
			}

			if(m_pImagePtr != NULL)
			{
//				delete m_pImagePtr;
				m_pImagePtr = NULL;
			}

			FO_IMAGETYPE type = CFODrawHelper::FindType(ext);
			m_strImageFile = strFileName;
			BOOL bLoad = LoadImage(strFileName,type);

			if(!bLoad)
			{
				return FALSE;
			}
			int nAngle = 0;
			CFOBitmap *pTempImage = m_pImagePtr->GetBitmap();
			m_DrawImage.m_nAngle = nAngle;
			m_DrawImage.RebuildImage(pTempImage);
			
			return FALSE;
		}
	}
	return FALSE;
}

void CMyBackShape::CancelImage()
{
	if(m_pImageRotatePtr != NULL)
	{
		delete m_pImageRotatePtr;
		m_pImageRotatePtr = NULL;
	}
	
	if(m_pImagePtrOrMask != NULL)
	{
		delete m_pImagePtrOrMask;
		m_pImagePtrOrMask = NULL;
	}
	
	if(m_pImagePtrAndMask != NULL)
	{
		delete m_pImagePtrAndMask;
		m_pImagePtrAndMask = NULL;
	}

	if(m_pImagePtr != NULL)
	{
//		delete m_pImagePtr;
		m_pImagePtr = NULL;
	}
}

void CMyBackShape::DrawFormDialogButton(CDC *pDC,CRect &rect)
{
	CRect rcTitle = rect;
	CRect rcClose = CRect(rcTitle.right-18,rcTitle.top+2,rcTitle.right-2,rcTitle.top+16);
	CFOFormProperties *pProp = m_pModel->GetDefaultProperty();
	if(pProp->HasCloseButton())
	{
		pDC->DrawFrameControl(&rcClose,DFC_CAPTION,DFCS_CAPTIONCLOSE);
		if(pProp->HasMaxButton())
		{
			if(pProp->HasMinButton())
			{
				rcClose.OffsetRect(CPoint(-18,0));
				pDC->DrawFrameControl(&rcClose,DFC_CAPTION,DFCS_CAPTIONMAX);
				rcClose.OffsetRect(CPoint(-16,0));
				pDC->DrawFrameControl(&rcClose,DFC_CAPTION,DFCS_CAPTIONMIN);
			}
			else
			{
				rcClose.OffsetRect(CPoint(-18,0));
				pDC->DrawFrameControl(&rcClose,DFC_CAPTION,DFCS_CAPTIONMAX);
				rcClose.OffsetRect(CPoint(-16,0));
				pDC->DrawFrameControl(&rcClose,DFC_CAPTION,DFCS_CAPTIONMIN|DFCS_INACTIVE);
			}
		}
		else
		{
			if(pProp->HasMinButton())
			{
				rcClose.OffsetRect(CPoint(-18,0));
				pDC->DrawFrameControl(&rcClose,DFC_CAPTION,DFCS_CAPTIONMAX|DFCS_INACTIVE);
				rcClose.OffsetRect(CPoint(-16,0));
				pDC->DrawFrameControl(&rcClose,DFC_CAPTION,DFCS_CAPTIONMIN);
			}
			else
			{
				if(pProp->HasHelpButton())
				{
					rcClose.OffsetRect(CPoint(-18,0));
					pDC->DrawFrameControl(&rcClose,DFC_CAPTION,DFCS_CAPTIONHELP);
				}
			}
		}
	}
	else if(pProp->HasMaxButton())
	{
		pDC->DrawFrameControl(&rcClose,DFC_CAPTION,DFCS_CAPTIONCLOSE);
		
		if(pProp->HasMinButton())
		{
			rcClose.OffsetRect(CPoint(-18,0));
			pDC->DrawFrameControl(&rcClose,DFC_CAPTION,DFCS_CAPTIONMAX);
			rcClose.OffsetRect(CPoint(-16,0));
			pDC->DrawFrameControl(&rcClose,DFC_CAPTION,DFCS_CAPTIONMIN);
		}
		else
		{
			rcClose.OffsetRect(CPoint(-18,0));
			pDC->DrawFrameControl(&rcClose,DFC_CAPTION,DFCS_CAPTIONMAX);
			rcClose.OffsetRect(CPoint(-16,0));
			pDC->DrawFrameControl(&rcClose,DFC_CAPTION,DFCS_CAPTIONMIN|DFCS_INACTIVE);
		}

	
	}
	else if(pProp->HasMinButton())
	{
		pDC->DrawFrameControl(&rcClose,DFC_CAPTION,DFCS_CAPTIONCLOSE);
		
		if(pProp->HasMaxButton())
		{
			
			rcClose.OffsetRect(CPoint(-18,0));
			pDC->DrawFrameControl(&rcClose,DFC_CAPTION,DFCS_CAPTIONMAX);
			rcClose.OffsetRect(CPoint(-16,0));
			pDC->DrawFrameControl(&rcClose,DFC_CAPTION,DFCS_CAPTIONMIN);
			
		}
		else
		{
			
			rcClose.OffsetRect(CPoint(-18,0));
			pDC->DrawFrameControl(&rcClose,DFC_CAPTION,DFCS_CAPTIONMAX|DFCS_INACTIVE);
			rcClose.OffsetRect(CPoint(-16,0));
			pDC->DrawFrameControl(&rcClose,DFC_CAPTION,DFCS_CAPTIONMIN);
			
		}
		
	}
}

BOOL CMyBackShape::LoadImage(UINT nID, LPCTSTR pcszResourceType,const FO_IMAGETYPE &nImageType,COLORREF crTransparent)
{
//	ASSERT(AfxCheckMemory());

	m_nImageType = (int)nImageType;

	CFODrawImageData pImagePointer = NULL;
	BOOL bIsLoaded = FALSE;
	switch(nImageType)
	{
	case FO_IMAGE_BMP: // Load bitmap file.
		{
			pImagePointer = new CFODrawImage();

			CFOImageIcon *pImage = static_cast<CFOImageIcon *>(pImagePointer->GetBitmap());
			bIsLoaded = pImage->Read(nID);
			
			if(bIsLoaded)
			{
				CString strImage;
				long x = (long)rand() * (long)rand();
				strImage.Format(_T("Image%d%d"),nID,x);
				pImagePointer->m_strImageDes = strImage;
				
				m_pImagePtr = m_ImageData.FindImage(pImagePointer);
				
				CRect rcTemp = DoInitImagePos(m_pImagePtr->GetBitmap()->GetWidthExt(),m_pImagePtr->GetBitmap()->GetHeightExt());
				m_rectPosition = rcTemp;
			}
		}
		break;

	case FO_IMAGE_ICO: // Load icon file
		{
			pImagePointer = new CFODrawImage();

			CFOImageIcon *pImage = static_cast<CFOImageIcon *>(pImagePointer->GetBitmap());
			bIsLoaded = pImage->LoadIconID(nID,crTransparent);
			
			if(bIsLoaded)
			{
				CString strImage;
				long x = (long)rand() * (long)rand();
				strImage.Format(_T("Image%d%d"),nID,x);
				pImagePointer->m_strImageDes = strImage;
				
				m_pImagePtr = m_ImageData.FindImage(pImagePointer);
				
				CRect rcTemp = DoInitImagePos(m_pImagePtr->GetBitmap()->GetWidthExt(),m_pImagePtr->GetBitmap()->GetHeightExt());
				m_rectPosition = rcTemp;
			}
		}
		break;

	case FO_IMAGE_PCX: // Load pcx file.
		{
			pImagePointer = new CFODrawImagePCX();

			CFOImagePCX *pImage = static_cast<CFOImagePCX *>(pImagePointer->GetBitmap());
			bIsLoaded = pImage->Read(nID,pcszResourceType);

			if(bIsLoaded)
			{
				CString strImage;
				long x = (long)rand() * (long)rand();
				strImage.Format(_T("Image%d%d"),nID,x);
				pImagePointer->m_strImageDes = strImage;
				
				m_pImagePtr = m_ImageData.FindImage(pImagePointer);
				
				CRect rcTemp = DoInitImagePos(m_pImagePtr->GetBitmap()->GetWidthExt(),m_pImagePtr->GetBitmap()->GetHeightExt());
				m_rectPosition = rcTemp;
			}
		}
		break;

	case FO_IMAGE_JPG: // Load jpeg file.
		{
			pImagePointer = new CFODrawImageJPEG();

			CFOImageJPEG *pImage = static_cast<CFOImageJPEG *>(pImagePointer->GetBitmap());
			bIsLoaded = pImage->Read(nID,pcszResourceType);
			
			if(bIsLoaded)
			{
				CString strImage;
				long x = (long)rand() * (long)rand();
				strImage.Format(_T("Image%d%d"),nID,x);
				pImagePointer->m_strImageDes = strImage;
				
				m_pImagePtr = m_ImageData.FindImage(pImagePointer);
				
				CRect rcTemp = DoInitImagePos(m_pImagePtr->GetBitmap()->GetWidthExt(),m_pImagePtr->GetBitmap()->GetHeightExt());
				m_rectPosition = rcTemp;
			}
		}
		break;

	case FO_IMAGE_PNG: // Load png file.
		{
			pImagePointer = new CFODrawImagePNG();

			CFOImagePNG *pImage = static_cast<CFOImagePNG *>(pImagePointer->GetBitmap());
			bIsLoaded = pImage->Read(nID,pcszResourceType);
			
			if(bIsLoaded)
			{
				CString strImage;
				long x = (long)rand() * (long)rand();
				strImage.Format(_T("Image%d%d"),nID,x);
				pImagePointer->m_strImageDes = strImage;
				
				m_pImagePtr = m_ImageData.FindImage(pImagePointer);
				
				CRect rcTemp = DoInitImagePos(m_pImagePtr->GetBitmap()->GetWidthExt(),m_pImagePtr->GetBitmap()->GetHeightExt());
				m_rectPosition = rcTemp;
			}
		}
		break;

	case FO_IMAGE_GIF: // Load GIF file.
		{
			CFODrawImageGIF *pPoint = new CFODrawImageGIF();
			bIsLoaded = pPoint->Read(nID,pcszResourceType);

			pImagePointer = pPoint;

			if(bIsLoaded)
			{
				CString strImage;
				long x = (long)rand() * (long)rand();
				strImage.Format(_T("Image%d%d"),nID,x);
				pImagePointer->m_strImageDes = strImage;
				
				m_pImagePtr = m_ImageData.FindImage(pImagePointer);
				
				CRect rcTemp = DoInitImagePos(pPoint->GetTotalImageSize().cx,
					pPoint->GetTotalImageSize().cy);
				m_rectPosition = rcTemp;

				m_bGif					= TRUE;

			}
		}
		break;

	case FO_IMAGE_TGA: // Load TGA file.
		{
			pImagePointer = new CFODrawImageTGA();

			CFOImageTGA *pImage = static_cast<CFOImageTGA *>(pImagePointer->GetBitmap());
			bIsLoaded = pImage->Read(nID,pcszResourceType);
			
			if(bIsLoaded)
			{
				CString strImage;
				long x = (long)rand() * (long)rand();
				strImage.Format(_T("Image%d%d"),nID,x);
				pImagePointer->m_strImageDes = strImage;
				
				m_pImagePtr = m_ImageData.FindImage(pImagePointer);
				
				CRect rcTemp = DoInitImagePos(m_pImagePtr->GetBitmap()->GetWidthExt(),m_pImagePtr->GetBitmap()->GetHeightExt());
				m_rectPosition = rcTemp;
			}
		}
		break;

	case FO_IMAGE_MNG: // Load Mng file.
		{
			CFODrawImageMNG *pPoint = new CFODrawImageMNG();
			bIsLoaded = pPoint->Read(nID,pcszResourceType);

			pImagePointer = pPoint;

			if(bIsLoaded)
			{
				CString strImage;
				long x = (long)rand() * (long)rand();
				strImage.Format(_T("Image%d%d"),nID,x);
				pImagePointer->m_strImageDes = strImage;
				
				m_pImagePtr = m_ImageData.FindImage(pImagePointer);
				
				CRect rcTemp = DoInitImagePos(m_pImagePtr->GetBitmap()->GetWidthExt(),m_pImagePtr->GetBitmap()->GetHeightExt());
				m_rectPosition = rcTemp;
			}
		}
		break;

	default: // Load bitmap file or icon file.
		{
			pImagePointer = new CFODrawImage();

			CFOImageIcon *pImage = static_cast<CFOImageIcon *>(pImagePointer->GetBitmap());
			bIsLoaded = pImage->Read(nID);
			
			if(!bIsLoaded)
			{
				bIsLoaded = pImage->LoadIconID(nID,crTransparent);
			}
			
			if(bIsLoaded)
			{
				CString strImage;
				long x = (long)rand() * (long)rand();
				strImage.Format(_T("Image%d%d"),nID,x);
				pImagePointer->m_strImageDes = strImage;
				
				m_pImagePtr = m_ImageData.FindImage(pImagePointer);
				
				CRect rcTemp = DoInitImagePos(m_pImagePtr->GetBitmap()->GetWidthExt(),m_pImagePtr->GetBitmap()->GetHeightExt());
				m_rectPosition = rcTemp;
			}
		}
		break;
	}

	if(m_pImagePtrOrMask != NULL)
	{
		delete m_pImagePtrOrMask;
		m_pImagePtrOrMask = NULL;
	}

	if(m_pImagePtrAndMask != NULL)
	{
		delete m_pImagePtrAndMask;
		m_pImagePtrAndMask = NULL;
	}
//	ASSERT(AfxCheckMemory());
	return bIsLoaded;
}

/////////////////////////////////////////////////////////////////////////////
BOOL CMyBackShape::LoadImage(CString strImagePath,const FO_IMAGETYPE &nImageType,COLORREF crTransparent)
{
//	ASSERT(AfxCheckMemory());

	m_nImageType = (int)nImageType;
	CFODrawImageData pImagePointer = NULL;
	BOOL bIsLoaded = FALSE;
	switch(nImageType)
	{
	case FO_IMAGE_BMP: // Load bitmap file.
		{
			pImagePointer = new CFODrawImage();

			CFOImageIcon *pImage = static_cast<CFOImageIcon *>(pImagePointer->GetBitmap());
			bIsLoaded = pImage->Read(strImagePath);
			
			if(bIsLoaded)
			{
				CString strImage;
				strImage = strImagePath;
				pImagePointer->m_strImageDes = strImage;
				
				m_pImagePtr = m_ImageData.FindImage(pImagePointer);
				
				CRect rcTemp = DoInitImagePos(m_pImagePtr->GetBitmap()->GetWidthExt(),m_pImagePtr->GetBitmap()->GetHeightExt());
				m_rectPosition = rcTemp;
			}
		}
		break;

	case FO_IMAGE_ICO: // Load icon file
		{
			pImagePointer = new CFODrawImage();

			CFOImageIcon *pImage = static_cast<CFOImageIcon *>(pImagePointer->GetBitmap());
			bIsLoaded = pImage->LoadIconFile(strImagePath,crTransparent);
			
			if(bIsLoaded)
			{
				CString strImage;
				strImage = strImagePath;
				pImagePointer->m_strImageDes = strImage;
				
				m_pImagePtr = m_ImageData.FindImage(pImagePointer);
				
				CRect rcTemp = DoInitImagePos(m_pImagePtr->GetBitmap()->GetWidthExt(),m_pImagePtr->GetBitmap()->GetHeightExt());
				m_rectPosition = rcTemp;
			}
		}
		break;

	case FO_IMAGE_PCX: // Load pcx file.
		{
			pImagePointer = new CFODrawImagePCX();

			CFOImagePCX *pImage = static_cast<CFOImagePCX *>(pImagePointer->GetBitmap());
			bIsLoaded = pImage->Read(strImagePath);

			if(bIsLoaded)
			{
				CString strImage;
				strImage = strImagePath;
				pImagePointer->m_strImageDes = strImage;
				
				m_pImagePtr = m_ImageData.FindImage(pImagePointer);
				
				CRect rcTemp = DoInitImagePos(m_pImagePtr->GetBitmap()->GetWidthExt(),m_pImagePtr->GetBitmap()->GetHeightExt());
				m_rectPosition = rcTemp;
			}
		}
		break;

	case FO_IMAGE_JPG: // Load jpeg file.
		{
			pImagePointer = new CFODrawImageJPEG();

			CFOImageJPEG *pImage = static_cast<CFOImageJPEG *>(pImagePointer->GetBitmap());
			bIsLoaded = pImage->Read(strImagePath);

			if(bIsLoaded)
			{
				CString strImage;
				strImage = strImagePath;
				pImagePointer->m_strImageDes = strImage;
				
				m_pImagePtr = m_ImageData.FindImage(pImagePointer);
				
				CRect rcTemp = DoInitImagePos(m_pImagePtr->GetBitmap()->GetWidthExt(),m_pImagePtr->GetBitmap()->GetHeightExt());
				m_rectPosition = rcTemp;
			}
		}
		break;

	case FO_IMAGE_PNG: // Load png file.
		{
			pImagePointer = new CFODrawImagePNG();

			CFOImagePNG *pImage = static_cast<CFOImagePNG *>(pImagePointer->GetBitmap());
			bIsLoaded = pImage->Read(strImagePath);
			
			if(bIsLoaded)
			{
				CString strImage;
				strImage = strImagePath;
				pImagePointer->m_strImageDes = strImage;
				
				m_pImagePtr = m_ImageData.FindImage(pImagePointer);
				
				CRect rcTemp = DoInitImagePos(m_pImagePtr->GetBitmap()->GetWidthExt(),m_pImagePtr->GetBitmap()->GetHeightExt());
				m_rectPosition = rcTemp;
			}
		}
		break;

	case FO_IMAGE_GIF: // Load GIF file.
		{
			CFODrawImageGIF *pPoint = new CFODrawImageGIF();
			bIsLoaded = pPoint->Read(strImagePath);
			pImagePointer = pPoint;
			
			if(bIsLoaded)
			{
				CString strImage;
				strImage = strImagePath;
				pImagePointer->m_strImageDes = strImage;
				
				m_pImagePtr = m_ImageData.FindImage(pImagePointer);
				
				CRect rcTemp = DoInitImagePos(pPoint->GetTotalImageSize().cx,
					pPoint->GetTotalImageSize().cy);
				m_rectPosition = rcTemp;

				m_bGif					= TRUE;
			}
		}
		break;

	case FO_IMAGE_TGA: // Load TGA file.
		{
			pImagePointer = new CFODrawImageTGA();

			CFOImageTGA *pImage = static_cast<CFOImageTGA *>(pImagePointer->GetBitmap());
			bIsLoaded = pImage->Read(strImagePath);
			
			if(bIsLoaded)
			{
				CString strImage;
				strImage = strImagePath;
				pImagePointer->m_strImageDes = strImage;
				
				m_pImagePtr = m_ImageData.FindImage(pImagePointer);
				
				CRect rcTemp = DoInitImagePos(m_pImagePtr->GetBitmap()->GetWidthExt(),m_pImagePtr->GetBitmap()->GetHeightExt());
				m_rectPosition = rcTemp;
			}
		}
		break;

	case FO_IMAGE_MNG: // Load MNG file.
		{
			CFODrawImageMNG *pPoint = new CFODrawImageMNG();
			bIsLoaded = pPoint->Read(strImagePath);

			pImagePointer = pPoint;
			
			if(bIsLoaded)
			{
				CString strImage;
				strImage = strImagePath;
				pImagePointer->m_strImageDes = strImage;
				
				m_pImagePtr = m_ImageData.FindImage(pImagePointer);
				
				CRect rcTemp = DoInitImagePos(m_pImagePtr->GetBitmap()->GetWidthExt(),m_pImagePtr->GetBitmap()->GetHeightExt());
				m_rectPosition = rcTemp;
			}
		}
		break;

	default: // Load bitmap file or icon file.
		{
			pImagePointer = new CFODrawImage();

			CFOImageIcon *pImage = static_cast<CFOImageIcon *>(pImagePointer->GetBitmap());
			bIsLoaded = pImage->Read(strImagePath);
			
			if(!bIsLoaded)
			{
				bIsLoaded = pImage->LoadIconFile(strImagePath,crTransparent);
			}
			
			if(bIsLoaded)
			{
				CString strImage;
				strImage = strImagePath;
				pImagePointer->m_strImageDes = strImage;
				
				m_pImagePtr = m_ImageData.FindImage(pImagePointer);
				
				CRect rcTemp = DoInitImagePos(m_pImagePtr->GetBitmap()->GetWidthExt(),m_pImagePtr->GetBitmap()->GetHeightExt());
				m_rectPosition = rcTemp;
			}
		}
		break;
	}

	if(m_pImagePtrOrMask != NULL)
	{
		delete m_pImagePtrOrMask;
		m_pImagePtrOrMask = NULL;
	}

	if(m_pImagePtrAndMask != NULL)
	{
		delete m_pImagePtrAndMask;
		m_pImagePtrAndMask = NULL;
	}
//	ASSERT(AfxCheckMemory());
	return bIsLoaded;
}

void CMyBackShape::OffsetImage(CPoint ptNew)
{
	if(IsValidate())
	{
		m_rectPosition = FOPRect(ptNew.x, ptNew.y, ptNew.x + m_rectPosition.Width(), ptNew.y + m_rectPosition.Height());
	}
}

CRect CMyBackShape::DoInitImagePos(int nImageWidth,int nImageHeight)
{
	CRect rcTemp = CRect(m_rectPosition.left,
		m_rectPosition.top,
		m_rectPosition.left+nImageWidth,
		m_rectPosition.top +nImageHeight);
	
	rcTemp.NormalizeRect();
	return rcTemp;
}

void CMyBackShape::SetImageTransparentColor(const COLORREF crTrans)
{
	if(m_pImagePtrOrMask != NULL)
	{
		delete m_pImagePtrOrMask;
		m_pImagePtrOrMask = NULL;
	}
	
	if(m_pImagePtrAndMask != NULL)
	{
		delete m_pImagePtrAndMask;
		m_pImagePtrAndMask = NULL;
	}
	m_crImageTransparent = crTrans;
}

void CMyBackShape::SetImageTransparent(const BOOL bTrans)
{
	if(m_pImagePtrOrMask != NULL)
	{
		delete m_pImagePtrOrMask;
		m_pImagePtrOrMask = NULL;
	}
	if(m_pImagePtrAndMask != NULL)
	{
		delete m_pImagePtrAndMask;
		m_pImagePtrAndMask = NULL;
	}
	
	m_bImageTransparent = bTrans;
}

BOOL CMyBackShape::IsValidate()
{
	BOOL bDraw = FALSE;
	if(m_pImagePtr != NULL)
	{
		if(m_pImagePtr->GetBitmap()->IsValidate())
		{
			return TRUE;
		}
	}

	return bDraw;
}

void CMyBackShape::Serialize(CArchive& ar)
{
	m_ImageColorProp.Serialize(ar);
	m_ImageData.RemoveData();
	CFOBackShape::Serialize(ar);

	if(ar.IsStoring())
	{
		ar << m_strImageFile;
		ar << m_bImageTransparent;
		ar << m_crImageTransparent;
		ar << m_rectPosition;
		ar << m_ptImageStart;
		ar	<< m_bCenterImage;
	}
	else
	{
		m_strImageFile = _T("");
		if(m_nVersion >= 3)
		{
			ar >> m_strImageFile;
			ar >> m_bImageTransparent;
			ar >> m_crImageTransparent;
			
			ar >> m_rectPosition;
			ar >> m_ptImageStart;
			ar >> m_bCenterImage;
		
		}
		SetNewImage(m_strImageFile);
	}

}

void CMyBackShape::DoDrawImage(CDC *pDC,CRect rcPos)
{

	BOOL bDraw = FALSE;
	if(m_pImagePtr != NULL)
	{
		if(m_pImagePtr->GetBitmap()->IsValidate())
		{
			bDraw = TRUE;
		}
	}

	if(bDraw)
	{
			int nAngle = 0;
			
			int m_nBlue           = 0;
			int m_nRed            = 0;
			int m_nGreen          = 0;
			int m_nBright         = 0;
			int m_nCont           = 0;
			float m_fGamma          = 10.0f;


			{
				m_nBlue = m_ImageColorProp.GetBlue();
				m_nRed = m_ImageColorProp.GetRed();
				m_nGreen = m_ImageColorProp.GetGreen();
				m_nBright = m_ImageColorProp.GetBright();
				m_nCont = m_ImageColorProp.GetCont();
				m_fGamma = m_ImageColorProp.GetGamma();
			}

			CFOBitmap *pTempImage = m_pImagePtr->GetBitmap();
			CFOBitmap *pDrawBitmap = pTempImage;
			if(nAngle == 0 &&
				m_nBright == 0 &&
				m_nCont == 0 &&
				m_nRed == 0 &&
				m_nGreen == 0 &&
				m_nBlue == 0 &&
				m_fGamma == 10.0f)
			{
				pDrawBitmap = pTempImage;
			}
			else if(pTempImage != NULL)
			{
				if(nAngle == 0 &&
					m_nBright == 0 &&
					m_nCont == 0 &&
					m_nRed == 0 &&
					m_nGreen == 0 &&
					m_nBlue == 0 &&
				m_fGamma == 10.0f)
				{
					pDrawBitmap = m_pImagePtr->GetBitmap();
				}
				else
				{
					if(m_DrawImage.IsRotateChanged(nAngle) || m_DrawImage.IsAdjustChanged(m_nBright,m_nCont,m_nRed,m_nGreen,m_nBlue,
					m_fGamma))
					{
						if(m_pImageRotatePtr != NULL)
							delete m_pImageRotatePtr;
						m_pImageRotatePtr = NULL;
					}
					 
					if(m_pImageRotatePtr != NULL)
					{
						pDrawBitmap = m_pImageRotatePtr->GetBitmap();
					}
					else
					{
						m_DrawImage.m_nAngle = nAngle;
						
						CFODrawImage* pImagePointer = new CFODrawImage();
						CFOImageIcon *pImage = static_cast<CFOImageIcon *>(pImagePointer->GetBitmap());
						pImage->Backup(pTempImage);
						if(nAngle != -10000)
						{
							if(pImage->GetBitCount() != 24 && (nAngle != 0))
							{
								pImage->ConvertTo24Bits();
							}
							pImage->Rotate(nAngle,RGB(255,255,255));
						}
						
						if(
							m_nBlue                         != 0 || 
							m_nRed                          != 0 || 
							m_nGreen                        != 0 || 
							m_nBright                       != 0 || 
							m_nCont                         != 0 || 
							m_fGamma                        != 10.0 )
						{
							pImage->Adjust((short)m_nBright,(short)m_nCont,(short)m_nRed,
								(short)m_nGreen,(short)m_nBlue,(double)m_fGamma);
						}
						
						CString strImage;
						long x = (long)rand() * (long)rand();
						strImage.Format(_T("Image%d%d"),nAngle+m_fGamma+m_nBright,x);
						pImagePointer->m_strImageDes = strImage;
						
						m_pImageRotatePtr = pImagePointer;
						pDrawBitmap = m_pImageRotatePtr->GetBitmap();
					}
				}

			}
			
			ASSERT(pDrawBitmap != NULL);

			CPalette* pPrevPal = NULL;
			
			if (pDrawBitmap->m_hPalette != NULL)
			{
				pPrevPal = pDC->SelectPalette(pDrawBitmap->m_hPalette, FALSE);
				pDC->RealizePalette();
			}
			
			if(m_bImageTransparent)
			{
				{
					if(nAngle == 0)
					{
						rcPos = CorrectImageRect(rcPos, pDrawBitmap->GetWidth(), pDrawBitmap->GetHeight());
					}

					if(m_pImagePtrAndMask == NULL || m_pImagePtrOrMask == NULL)
					{
						CDC srcDC;
						srcDC.CreateCompatibleDC(0);
						
						CPalette *pPrevSrcPal = NULL;
						if (pDrawBitmap->m_hPalette != NULL)
						{
							pPrevSrcPal = srcDC.SelectPalette(pDrawBitmap->m_hPalette, FALSE);
							srcDC.RealizePalette();
						}
						
						HDC hdcTmp = ::GetDC(0);
						HBITMAP hBmp = ::CreateDIBitmap(hdcTmp,
							&(pDrawBitmap->m_lpBMI->bmiHeader),
							CBM_INIT,
							pDrawBitmap->m_lpBuf,
							pDrawBitmap->m_lpBMI,
							DIB_RGB_COLORS);
						::ReleaseDC(0, hdcTmp);
						
						CBitmap* pSrcBmp = new CBitmap();
						pSrcBmp->Attach(hBmp);
						
						CBitmap *pPrevSrcBmp = srcDC.SelectObject(pSrcBmp);
						
						CDC andDC;
						andDC.CreateCompatibleDC(0);
						CPalette *pPrevAndPal = NULL;
						if (pDrawBitmap->m_hPalette != NULL)
						{
							pPrevAndPal = andDC.SelectPalette(pDrawBitmap->m_hPalette, FALSE);
							andDC.RealizePalette();
						}
						CBitmap *pAndBmp = new CBitmap();
						pAndBmp->CreateBitmap(pDrawBitmap->GetWidthExt(), pDrawBitmap->GetHeightExt(), 1, 1, NULL);
						CBitmap *pPrevAndBmp = andDC.SelectObject(pAndBmp);
						COLORREF prevColor = srcDC.SetBkColor(m_crImageTransparent);
						andDC.BitBlt(0, 0,
							pDrawBitmap->GetWidthExt(),
							pDrawBitmap->GetHeightExt(),
							&srcDC,
							0, 0,
							SRCCOPY);
						srcDC.SetBkColor(prevColor);
						
						delete m_pImagePtrAndMask;
						m_pImagePtrAndMask = new CFOBitmap();
						m_pImagePtrAndMask->MakeNewBitmap(&andDC, pAndBmp);
						
						CDC orDC;
						orDC.CreateCompatibleDC(0);
						CPalette *pPrevOrPal = NULL;
						if (pDrawBitmap->m_hPalette != NULL)
						{
							pPrevOrPal = orDC.SelectPalette(pDrawBitmap->m_hPalette, FALSE);
							orDC.RealizePalette();
						}
						CBitmap *pOrBmp = new CBitmap();
						pOrBmp->CreateCompatibleBitmap(&srcDC, pDrawBitmap->GetWidthExt(), pDrawBitmap->GetHeightExt());
						CBitmap *pPrevOrBmp = orDC.SelectObject(pOrBmp);
						orDC.BitBlt(0, 0, pDrawBitmap->GetWidthExt(), pDrawBitmap->GetHeightExt(),
							&andDC,
							0, 0,
							NOTSRCCOPY);
						
						orDC.BitBlt(0, 0, pDrawBitmap->GetWidthExt(), pDrawBitmap->GetHeightExt(),
							&srcDC,
							0, 0,
							SRCAND);
						
						delete m_pImagePtrOrMask;
						m_pImagePtrOrMask = new CFOBitmap();
						m_pImagePtrOrMask->MakeNewBitmap(&orDC, pOrBmp);
						
						andDC.SelectObject(pPrevAndBmp);
						if (pPrevAndPal != NULL)
						{
							andDC.SelectPalette(pPrevAndPal, FALSE);
						}
						delete pAndBmp;
						
						orDC.SelectObject(pPrevOrBmp);
						if (pPrevOrPal != NULL)
						{
							orDC.SelectPalette(pPrevOrPal, FALSE);
						}
						delete pOrBmp;
						
						srcDC.SelectObject(pPrevSrcBmp);
						if (pPrevSrcPal != NULL)
						{
							srcDC.SelectPalette(pPrevSrcPal, FALSE);
						}
						delete pSrcBmp;
					}
					
					CPalette *pPrevDstPal = NULL;
					if (pDrawBitmap->m_hPalette != NULL)
					{
						pPrevDstPal = pDC->SelectPalette(pDrawBitmap->m_hPalette, FALSE);
						pDC->RealizePalette();
					}
					
					COLORREF prevColor = pDC->SetBkColor(m_crImageTransparent);
					
					BOOL bIsInvert = CFODrawHelper::IsAxisInvert(*pDC);
					CPoint ptText(rcPos.top, rcPos.Height());
					if (bIsInvert)
					{
						ptText.x = rcPos.top + rcPos.Height();
						ptText.y = - rcPos.Height();
					}

					::StretchDIBits(pDC->GetSafeHdc(),
						rcPos.left, ptText.x,
						rcPos.Width(), ptText.y,
						0, 0,
						pDrawBitmap->GetWidth(), pDrawBitmap->GetHeight(),
						m_pImagePtrAndMask->m_lpBuf,
						m_pImagePtrAndMask->m_lpBMI,
						DIB_RGB_COLORS,
						SRCAND);
					
					::StretchDIBits(pDC->GetSafeHdc(),
						rcPos.left, ptText.x,
						rcPos.Width(), ptText.y,
						0, 0,
						pDrawBitmap->GetWidth(), pDrawBitmap->GetHeight(),
						m_pImagePtrOrMask->m_lpBuf,
						m_pImagePtrOrMask->m_lpBMI,
						DIB_RGB_COLORS,
						SRCPAINT);
					
					pDC->SetBkColor(prevColor);
					
					if (pPrevDstPal != NULL)
					{
						pDC->SelectPalette(pPrevDstPal, FALSE);
					}
				}
			}
			else
			{
				
				if(nAngle == 0)
				{
					rcPos = CorrectImageRect(rcPos, pDrawBitmap->GetWidth(), pDrawBitmap->GetHeight());
				}

				CFOPVisualProxy::GetInstance()->DoDrawBitmap(pDC, pDrawBitmap, rcPos, 0,0,
					pDrawBitmap->GetWidth(),   // height of source
				pDrawBitmap->GetHeight());


			}
        
			if (pPrevPal != NULL)
			{
				pDC->SelectPalette(pPrevPal, FALSE);
			}
	}


}

FOPRect CMyBackShape::CorrectImageRect(const FOPRect &rcOld, int nImageWidth, int nImageHeight)
{
	int m_nRealSize = 0;
//	GetPropIntValue(m_nRealSize, ID_IMAGE_RESIZE_TYPE);
	
	FOPRect rcDest(rcOld);
	FOPRect rcImage(rcOld);
	
	if (2 == m_nRealSize) // 0 -- no resize, 1 - resize freely, 2 resize ratio
	{
		int nItemWidth = rcDest.Width();
		int nItemHeight = rcDest.Height();
		
		double d1 = (double)((double)nItemHeight / (double)nItemWidth);
		double d2 = (double)((double)nImageHeight / (double)nImageWidth);
		double dWidth = 0.0;
		double dHeight = 0.0;
		if(d2 > d1)
		{
			dHeight = (double)nItemHeight;
			dWidth = (double)nImageWidth  * dHeight / (double)nImageHeight;
			
		}
		else
		{
			dWidth = (double)nItemWidth;
			dHeight = (double)nImageHeight * dWidth / (double)nImageWidth;
		}
		
		FOPRect rcNew;
		rcNew.CreateFromCenter(rcImage.CenterPoint(), FOPSize(CFODrawHelper::RoundValue(dWidth), 
			CFODrawHelper::RoundValue(dHeight)));
		return rcNew;
	}
	else if (1 == m_nRealSize) // Resize with ratio
	{
		return rcImage;
	}
	else  if (0 == m_nRealSize)
	{
		CRect rcDialog = m_pModel->GetPagePosition();
		if(m_bCenterImage)
		{
			FOPRect rcNew;
			rcNew.CreateFromCenter(rcDialog.CenterPoint(),  FOPSize(nImageWidth, nImageHeight));
			return rcNew;
		}
		else
		{
			FOPRect rcNew;
			rcNew.CreateFromCenter(rcImage.CenterPoint(),  FOPSize(nImageWidth, nImageHeight));
			return rcNew;
		}
		
	}
	else
	{
		return rcImage;
	}
}

BOOL CMyBackShape::RestoreDefaultSize()
{
//	CRect rcTemp = GetDrawRect();
//	rcTemp.NormalizeRect();

	BOOL bDraw = FALSE;
	if(m_pImagePtr != NULL)
	{
		if(m_pImagePtr->GetBitmap()->IsValidate())
		{
			bDraw = TRUE;
		}
	}

	if(bDraw)
	{
		{
			CFOBitmap *pTempImage = m_pImagePtr->GetBitmap();
			CFOBitmap *pDrawBitmap = pTempImage;
			ASSERT(pDrawBitmap != NULL);

			if(m_rectPosition.Width() == (int)pDrawBitmap->GetWidth() && m_rectPosition.Height() == (int)pDrawBitmap->GetHeight())
			{
				return FALSE;
			}

			FOPRect rcDefault(m_ptImageStart, CSize(pDrawBitmap->GetWidth(), pDrawBitmap->GetHeight()));
			m_rectPosition = rcDefault;
        }
	}
	else
	{
		FOPRect rcDefault(m_ptImageStart, CSize(100, 100));
		m_rectPosition = rcDefault;
	}

	return TRUE;
}

void CMyBackShape::OnDrawGrid(CDC *pDC,CRect &rect,const CRect &rcClip)
{
	CFOBackShape::OnDrawGrid(pDC,rect,rcClip);

	// FO:add your own code here.
	
}


void CMyBackShape::OnDrawBack(CDC *pDC,const CRect &rcClip)
{
	CFOBackShape::OnDrawBack(pDC,rcClip);

	CRect rcDraw = m_rectPosition;
	if(!rcDraw.IsRectEmpty())
	{
		DoDrawImage(pDC,rcDraw);
	}
}

void CMyBackShape::OnDrawPageMargin(CDC *pDC,CRect &rect,const CRect &rcClip)
{
	CFOBackShape::OnDrawPageMargin(pDC,rect,rcClip);
	
	// FO:add your own code here.

}

void CMyBackShape::DrawFormDragMark(CDC *pDC,CRect &rect)
{
	CFOBackShape::DrawFormDragMark(pDC,rect);
	
	// FO:add your own code here.

}


void CMyBackShape::OnDrawForm(CDC *pDC,const CRect &rcClip)
{
	CFOBackShape::OnDrawForm(pDC, rcClip);
	
}
 

